import { IRouter, Request, RequestHandler, Response } from './refs';
import { DebugSettings, SenderFunction } from './utils';
export interface NextFunction {
    (err?: any): void;
}
export interface ICCController {
    router: IRouter;
    debugSettings?: DebugSettings;
    setRoutes(): void;
    setDefaultRoutes(...middlewares: RequestHandler[]): IRouter;
    send(req: any, res: any, data: (err: any, data: any) => any | Object | any): void;
    error(req: any, res: any, data: Object): void;
    proxied(method: any): (req: Request, res: Response, next: NextFunction) => void;
    ctrl(name: string): RequestHandler;
}
export declare class CCController implements ICCController {
    router: IRouter;
    debugSettings: DebugSettings;
    constructor(router?: IRouter, debugSettings?: DebugSettings);
    setRoutes(): void;
    setDefaultRoutes(...middlewares: RequestHandler[]): IRouter;
    /**
     * Instead of returning the result you can use this method to pass the return result
     * @result {hashmap|}
     */
    send(req: any, res: any, data: (err: any, data: any) => any, senderFunction?: SenderFunction): void;
    senderFunction(res: any, err: any, data: any): any;
    error(req: any, res: any, data: Object): void;
    proxied(method: any): (req: any, res: any, next: NextFunction) => void;
    private _setProxiedMethods();
    ctrl(name: string): RequestHandler;
}
