import mongoose = require('mongoose');
import { CCController, ICCController } from './ccController';
import { CCService } from './ccService';
import { DebugSettings } from './utils';
import { IRouter, RequestHandler } from 'express';
export interface ICCServiceController<T extends mongoose.Document> extends ICCController {
    svc: CCService<T>;
    router: IRouter;
    debugSettings?: DebugSettings;
    paramsKey: string;
    setDefaultRoutes(...middlewares: RequestHandler[]): IRouter;
    index(req: any, res: any): PromiseLike<T[]>;
    view(req: any, res: any): PromiseLike<T>;
    remove(req: any, res: any): PromiseLike<T>;
    insert(req: any, res: any): PromiseLike<T>;
    update(req: any, res: any): PromiseLike<T>;
}
export declare class CCServiceController<T extends mongoose.Document> extends CCController implements ICCServiceController<T> {
    svc: CCService<T>;
    router: IRouter;
    debugSettings: DebugSettings;
    paramsKey: string;
    constructor(svc: CCService<T>, router?: IRouter, debugSettings?: DebugSettings);
    setDefaultRoutes(...middlewares: RequestHandler[]): IRouter;
    index(req: any, res: any): PromiseLike<T[]>;
    view(req: any, res: any): PromiseLike<T>;
    remove(req: any, res: any): PromiseLike<T>;
    insert(req: any, res: any): PromiseLike<T>;
    update(req: any, res: any): Promise<T>;
}
